// panning and zoom not working
// fixed the issue was that the difference between svg, zoomG and g

import { 
  				select, 
        	json, 
        	tree, 
  				hierarchy, 
  				linkHorizontal, 
  				linkVertical, 
  				cluster, 
  				event,
  				zoom
} from 'd3';

// the point of this code is to build a blank canvas that is of similar size as the window that it is in
//

const svg = select('svg');

const width = document.body.clientWidth;
const height = document.body.clientHeight;
const margin = { top: 0, right: 50, bottom: 0, left: 75};
const innerWidth = width - margin.left - margin.right;
const innerHeight = height - margin.top - margin.bottom;

const treeLayout = tree().size([innerHeight, innerWidth]);

const zoomG = svg
		.attr('width', width)
		.attr('height', height) 
	.append('g'); 

const g = zoomG.append('g')
    .attr('transform', `translate(${margin.left},${margin.top})`);

// this zoom and panning is not working 
svg.call(zoom().on('zoom', () => {
  zoomG.attr('transform', event.transform);
}));


// json function returns a promise
json('data.json')
	.then(data => {
  	const root = hierarchy(data);
  	const links = treeLayout(root).links(); // returns array of objects which are used for linkages
  	const linkPathGenerator = linkHorizontal()
    	.x(d => d.y)
  		.y(d => d.x);
  	
  
  	g.selectAll('path').data(links)
  		.enter().append('path')
  			.attr('d',linkPathGenerator);
  
  	g.selectAll('text').data(root.descendants())
  		.enter().append('text')
  			.attr('x', d => d.y)
  			.attr('y', d => d.x)
  			.attr('dy', '0.32em')
  			.attr('text-anchor', d => d.children ? 'middle' : 'start')
  			.attr('font-size', d => 3.25 - d.depth + 'em')
  			.text(d => d.data.data.id);
  
  
});
